local DGV = DugisGuideViewer
local AutoQuestLoot = DGV:RegisterModule("AutoQuestLoot")
AutoQuestLoot.essential = true

function AutoQuestLoot:Initialize()
	function DGV:LOOT_OPENED ()
		if GetCVar("AutoLootDefault") == "1" or not DGV:UserSetting(DGV_AUTOQUESTITEMLOOT) then return end
		for slot=1,GetNumLootItems() do
		end--GetQuestLogItemLink
		
		for questIndex = 1,GetNumQuestLogEntries() do
			for boardIndex = 1,GetNumQuestLeaderBoards(questIndex) do
				local leaderboardTxt, boardItemType, isDone = 
					GetQuestLogLeaderBoard(boardIndex,questIndex)
				if not isDone and boardItemType=="item" then
					local i, j, itemName, numItems, numNeeded = 
						string.find(leaderboardTxt, "(.*):%s*([%d]+)%s*/%s*([%d]+)")
					--DGV:DebugFormat("LOOT_OPENED", "itemName", itemName, "leaderboardTxt", leaderboardTxt)
					if itemName then
						for lootIndex = 1,GetNumLootItems() do
							local lootName = select(2,GetLootSlotInfo(lootIndex))
							DGV:DebugFormat("LOOT_OPENED", "lootName", lootName, "itemName", itemName)
							if lootName==itemName then
								LootSlot(lootIndex)
								--DGV:LOOT_OPENED()
								--return
							end
						end
					end
				end
			end
		end
	end
	
	function AutoQuestLoot:Load()
		DGV:RegisterEvent('LOOT_OPENED')
	end

	function AutoQuestLoot:Unload()
		DGV:UnregisterEvent('LOOT_OPENED')
	end
end