local MOD = DugisGuideViewer
local QuestPOI = MOD:RegisterModule("QuestPOI")
QuestPOI.essential = true

local QuestPOIFrame

local orig_WatchFrameQuestPOI_OnClick = WatchFrameQuestPOI_OnClick
local module_WatchFrameQuestPOI_OnClick = orig_WatchFrameQuestPOI_OnClick
function WatchFrameQuestPOI_OnClick(self, button)
	module_WatchFrameQuestPOI_OnClick(self, button)
end

function QuestPOI:Initialize()

	function MOD:InitializeQuestPOI()
		--DebugPrint("Debug: InitializeMiniQuestPOI");
		--Auto Select the current quest when the world map is opened
		--[[WorldMapFrame:HookScript("OnShow",
			function(arg)
				if _G["WorldMapQuestFrame1"]~=nil then
					DebugPrint("Debug WorldMapFrame_SelectQuestById")
					WorldMapFrame_SelectQuestById(DugisGuideViewer.qid[CurrentQuestIndex])
				end
			end);]]

		MOD:UpdateMiniBlobs()
	end

	function MOD:GetPOIByQID(qid)
		return MOD:IterateQuestPOIs(function(poi)
			local id = poi.questId or (poi.quest and poi.quest.questId)
			if id==qid then return poi end
		end, "WorldMapPOIFrame")
	end

	--WatchFrameLines
	--WorldMapPOIFrame
	function MOD:IterateQuestPOIs(delegate, parentName, numericPoiType)
		if not parentName then parentName="WorldMapPOIFrame" end
		if not numericPoiType then numericPoiType=QUEST_POI_NUMERIC end
		local numEntries = QuestMapUpdateAllQuests()
		local numEntries = QuestMapUpdateAllQuests()
		local breakVal = false
		if _G["poi"..parentName.."_Swap"] then
			breakVal = delegate(_G["poi"..parentName.."_Swap"])
		end
		if breakVal then return breakVal end
		local questCount = 0
		local numCompletedQuests = 0
		for i = 1, numEntries do
			local questId, questLogIndex = QuestPOIGetQuestIDByVisibleIndex(i);
		if ( questLogIndex and questLogIndex > 0 ) then
				questCount = questCount + 1;
				local isComplete = select(7, GetQuestLogTitle(questLogIndex))
				if ( isComplete ) then
					numCompletedQuests = numCompletedQuests + 1;
				end
				local poiButton = _G["poi"..parentName..tostring(numericPoiType).."_"..tostring(questCount - numCompletedQuests)];
				if poiButton then
					breakVal = delegate(poiButton)
					if breakVal then return breakVal end
				end
			end
		end
		return false
	end
	
	function QuestPOI:Load()
		MOD:InitializeQuestPOI()

		module_WatchFrameQuestPOI_OnClick = function(self, button)
			if ( button ~= "RightButton" ) then
				local qid = self.questId
				MOD.MapPreview.ForceMapPreview =
					(not WorldMapFrame:IsShown() or MOD.MapPreview:IsAnimating())
				and MOD:GetDB(DGV_MAPPREVIEWDURATION)~=0 and not MOD.carboniteloaded
					MOD:DebugFormat("WatchFrameQuestPOI_OnClick", "forceMapPreview", MOD.MapPreview.ForceMapPreview)

				if MOD.MapPreview.ForceMapPreview then
					MOD.MapPreview.SupressToggleMap = true
					WorldMap_OpenToQuest(qid)
				else
					orig_WatchFrameQuestPOI_OnClick(self, button)
				end
				local poi = MOD:GetPOIByQID(qid)
				if poi then
					MOD.DugisArrow:QuestPOIWaypoint(poi, true)
				end
			else
				orig_WatchFrameQuestPOI_OnClick(self, button)
			end
		end
	end

	function QuestPOI:Unload()
		module_WatchFrameQuestPOI_OnClick = orig_WatchFrameQuestPOI_OnClick
	end
end